/***************************************************
Copyright 2003 Darrell Johnson 

This file is part of Yu-gi-oh.

Yu-gi-oh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yu-gi-oh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Yu-gi-oh; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <dos.h>

#include "datatypes3.h"

extern Playing_Field_p pf;

extern int magic_trap_active[MAGICTRAP];
extern int magic_trap_active2[MAGICTRAP];

char magic_trap_registry[MAGICTRAP][40] = {"Armored Glass", "Castle Walls", "Dragon Capture Jar",
"Earthshaker", "Reinforcements", "Respect Play", "Trap Hole", "Two-pronged Attack",
"Ultimate Offering", "Waboku", "Book of Secret Arts", "Card Destruction", "Change of Heart", "Dark Hole",
"De-Spell", "Dian Keto the Cure Master", "Fissure", "Last Will", "Monster Reborn",
"Monster Recovery", "Remove Trap", "Soul Exchange", "Sword of Dark Destruction", "Yami", "Reverse Trap"};

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////Game Control Functions//////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

void SetUpBoards(void){
   int i;

   //player 1 board, all positions set to empty
	pf->b1 = (Board_p)malloc(sizeof(Board));
   pf->b1->position = (Boardpos_p*)calloc(10, sizeof(Boardpos));
   pf->b1->nomp = 0;
   pf->b1->nomtp = 5;
   pf->p1_field_card_active = 0;
   pf->b1->fieldcard = pf->blank;
   for(i=0;i<10;i++){
   	pf->b1->position[i] = (Boardpos_p)malloc(sizeof(Boardpos));
      pf->b1->position[i]->card = (Card_p)malloc(sizeof(Card));
      pf->b1->position[i]->card = pf->blank;
      pf->b1->position[i]->faced = -1;
      pf->b1->position[i]->pos = -1;
      pf->b1->position[i]->set = 0;
      pf->b1->position[i]->magic_atk = 0;
      pf->b1->position[i]->magic_def = 0;
      pf->b1->position[i]->equipped = 0;
      }

   //player 2 board, all positions set to empty
   pf->b2 = (Board_p)malloc(sizeof(Board));
   pf->b2->position = (Boardpos_p*)calloc(10, sizeof(Boardpos));
   pf->b2->nomp = 0;
   pf->b2->nomtp = 5;
   pf->p2_field_card_active = 0;
   pf->b2->fieldcard = pf->blank;
   for(i=0;i<10;i++){
   	pf->b2->position[i] = (Boardpos_p)malloc(sizeof(Boardpos));
      pf->b2->position[i]->card = (Card_p)malloc(sizeof(Card));
      pf->b2->position[i]->card = pf->blank;
      pf->b2->position[i]->faced = -1;
      pf->b2->position[i]->pos = -1;
      pf->b2->position[i]->set = 0;
      pf->b2->position[i]->magic_atk = 0;
      pf->b2->position[i]->magic_def = 0;
      pf->b2->position[i]->equipped = 0;
      }

	//player 1 graveyard
   pf->b1->graveyard = (Card_p*)calloc(pf->p1->entire_deck->numcards + 15, sizeof(Card));
   pf->b2->graveyard = (Card_p*)calloc(pf->p1->entire_deck->numcards + 15, sizeof(Card));
   for(i=0;i< pf->p1->entire_deck->numcards + 15; i++)
   	pf->b1->graveyard[i] = (Card_p)malloc(sizeof(Card));
   pf->b1->gy_pos = 0;

   for(i=0;i< pf->p2->entire_deck->numcards + 15; i++)
   	pf->b2->graveyard[i] = (Card_p)malloc(sizeof(Card));
   pf->b2->gy_pos = 0;

   }

//----This functions is only used for the first turn of the game.  Since the
//first player must skip the battle phase, this functions executes everything up
//to the Battle Phase, then ends.
void FirstTurn(void){

	//for now, i will have a dumb computer opponent.
   // that will draw one card each turn.  if a monster card, it will put it
   // in attack mode.  if the card is a magic or trap card, it will send the
   // card to the graveyard.  Magic and trap cards aren't implemented yet anyway
   //
	int in1, in2, i, choice, sa, anq, another_card;
   Board_p b;
	Player_p p = pf->p1;
   b = pf->b1;
   anq = 0;

	if(pf->turn == 1){
   	printf("***Computer draws one card from his deck\n");
      pf->p2->in_hand[5] = pf->p2->entire_deck->deck[5];
      pf->p2->entire_deck->topcardpos++;

      if(pf->p2->in_hand[5]->atk == -1 ){
      	pf->b2->position[5]->card = pf->p2->entire_deck->deck[5];
      	pf->b2->position[5]->faced = 0;
         pf->b2->position[5]->pos = 1;
      	pf->b2->nomtp++;
      	printf("Comp-U-Dueler played a card face down on board position 5.\n");
      	pf->p2->in_hand[5] = pf->blank;
         }
      else{
      	pf->b2->position[0]->card = pf->p2->entire_deck->deck[5];
      	pf->b2->position[0]->faced = 1;
         pf->b2->position[0]->pos = 1;
      	pf->b2->nomp++;
      	printf("Comp-U-Dueler played %s on board position 0 in attack mode\n", pf->b2->position[0]->card->name);
      	pf->p2->in_hand[5] = pf->blank;
         }
      }
   else{
   	DrawPhase(p);
   	printf("You are currently holding: \n");
   do{
   	for(i=0; i< p->ohp;i++){
   		printf("------------------------------------\n");
   		printf("%d. %s (atk %d / def %d) || level: %d || type: %s || attribute: %s\n", i, p->in_hand[i]->name, p->in_hand[i]->atk,
      		p->in_hand[i]->def, p->in_hand[i]->level, p->in_hand[i]->type, p->in_hand[i]->attribute);
      	printf("%s\n", p->in_hand[i]->description);
      	printf("------------------------------------\n");
         }
		printf("(a)ttack, (l)ook up card info, (s)witch cards from side deck: ");
   	fflush(stdin);
   	choice = getletter();
      fflush(stdin);

   	while(choice != 'a' && choice != 's' && choice != 'l'){
   		printf("(a)ttack, (l)ook up card info, (s)witch cards from side deck: ");
   		choice = getletter();
      	}

   	if(choice == 'l')
   		CardQuery();
   	if(choice == 's')
   		UseSideDeck();
  	}while(choice != 'a');

   do{
   	for(i=0; i< p->ohp;i++)
   	printf("%d. %s (atk %d / def %d) level %d\n", i, p->in_hand[i]->name, p->in_hand[i]->atk,
      	p->in_hand[i]->def, p->in_hand[i]->level);
   	printf("\nWhich card would you like to play?(0-%d): ", p->ohp-1);
   	in1 = getnumber();
   	while(isdigit(in1) && (in1 > 6) ){
   		printf("\nWhich card would you like to play?(0-%d): ", p->ohp-1);
   		in1 = getnumber();
      	}

   	if(p->in_hand[in1]->atk == -1){
      	printf("Placing on magic/trap card space.\n");
         if(!strcmp(p->in_hand[in1]->attribute, "trap") ){
         	printf("Setting %s.\n", p->in_hand[in1]->name);
         	PlaceOnBoard(p->in_hand[in1], pf->b1, 0, 0, 1);
         	UpdateHand(p, in1);
            }
         else{
         	printf("Set or Activate card? \nTrap cards must be set, Magic cards can be set or activated (s or a): ");
         	sa = getletter();
         	while(sa != 's' && sa != 'a'){
         		printf("Set or Activate card? (s or a): ");
         		sa = getletter();
            	}
         	if(sa == 's'){
         		printf("Setting %s for later use.\n", p->in_hand[in1]->name);
         		PlaceOnBoard(p->in_hand[in1], pf->b1, 0, 0, 1);
         		UpdateHand(p, in1);
            	}
         	if(sa == 'a'){
         		printf("Activating %s...\n", p->in_hand[in1]->name);
            	MagicAndTrapCards(p->in_hand[in1]->name);
         		PlaceOnBoard(p->in_hand[in1], pf->b1, 1, 0, 1);
         		UpdateHand(p, in1);
            	}
            }
         printf("Since you played a magic/trap card, you have the option to play another card.\n");
         another_card = 1;
         }
   	else{
    		printf("Place in (a)ttack or (d)efense mode: ");
    		in2 = getletter();
    		fflush(stdin);
         another_card = 0;
    		if(in2 == 'a'){
   			printf("%s placed in attack mode\n", p->in_hand[in1]->name);
      		PlaceOnBoard(p->in_hand[in1], b, 1, 1, 0);
      		UpdateHand(p, in1);
      		}
    		else{
   			printf("%s placed in defense mode\n", pf->p1->in_hand[in1]->name);
      		PlaceOnBoard(p->in_hand[in1], b, 0, 0, 0);
      		UpdateHand(p, in1);
      		}
   		}
      while(another_card && (anq != 'y') & (anq != 'n') ){
      	printf("Would you like to play another card? (y/n): ");
         anq = getletter();
         if(anq == 'n')
         	another_card = 0;
         }
      }while(another_card);
   }
}

//The game loop
int Duel (void){
	int i, winner;
   char file_input[1024];
   FILE *fp;

   i = rand() % 2;
   fp = fopen("duelascii.txt", "r");

   while( (fgets(file_input, 1024, fp) != NULL) ) {
  		printf("%s", file_input);
   }
   fclose(fp);
   printf("\n$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\n");

   if(i == 0) printf("\nPlayer 1 you may go first\n");
   else printf("\nComputer gets to go first\n");
   pf->turn = i;

   //an array of open card positions in the hand;
   pf->p1->in_hand = (Card_p*)calloc(6, sizeof(Card));
   for(i=0;i<6;i++)
   	pf->p1->in_hand[i] = (Card_p)malloc(sizeof(Card));

   pf->p1->lifepoints = 8000;

	//make a hand for player2
   pf->p2->in_hand = (Card_p*)calloc(6, sizeof(Card));
   for(i=0;i<6;i++)
   	pf->p2->in_hand[i] = (Card_p)malloc(sizeof(Card));

   pf->p2->lifepoints = 8000;

	//for first turn, a player can only participate in the draw phase and main phase.
   //So this will be implemented outside of the main loop.

   //draw 5 cards at beginning of the game
   for(i=0;i<5;i++)
   	pf->p1->in_hand[i] = pf->p1->entire_deck->deck[i];
   pf->p1->entire_deck->topcardpos = 5;
   pf->p1->ohp = 5;

   for(i=0;i<5;i++)
   	pf->p2->in_hand[i] = pf->p2->entire_deck->deck[i];
   pf->p2->entire_deck->topcardpos = 5;
   pf->p2->ohp = 5;

   FirstTurn();

   //Start duel loop
   winner = 0;  //1 = p1 win, 2 = p2 win

   while(!winner){
   	pf->turn = (pf->turn + 1) % 2; //0 = player 1 turn, 1 = computer turn
      UpdateScreen();
      Reset();
      if(!pf->turn){
      	DrawPhase(pf->p1);
         if(MainPhaseI(pf->p1, pf->b1)){
         	BattlePhase(pf->p1, pf->b1);
            }
         }
      else{
      	CompDrawPhase(pf->p2);
         if( CompMainPhaseI(pf->p2, pf->b2) ) CompBattlePhase(pf->p2, pf->b2);
      	}
      PostBattleMagic();
      printf("----------------------------------------------\n");
      if(pf->p1->lifepoints <= 0) winner = 2;
      if(pf->p2->lifepoints <= 0) winner = 1;
      CheckHands();
      }
   return winner;
}

void CheckHands(void){
	int in1;
   if(pf->p1->ohp >6){
      printf("You have too many cards in your hand.  You may only have 6 cards in your hand by the end of the your turn.\n");
      do{
      	printf("Choose a card in your hand to send to the graveyard. (0 - %d): ", pf->p1->ohp-1);
         in1 = getnumber();
         if(pf->p1->in_hand[in1] == NULL)
         	printf("Invalid choice.\n");
         else HandToGraveyard(pf->p1, pf->b1, in1);
      }while(pf->p1->ohp >6);
   }
   if(pf->p2->ohp > 6){
   	printf("Comp-U-Dueler has too many cards in its hand.  Discarding...\n");
      do{
      	//will always discard the first card in the hand for computuer
         HandToGraveyard(pf->p2, pf->b2, 0);
      }while(pf->p2->ohp > 6);
   }
}

////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////|----|/////////////////////////////////////////
/////////////////////////////////|Main|/////////////////////////////////////////
/////////////////////////////////|----|/////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

int main(){
	int who_won;
	fflush(NULL);
	printf("------------ooooooWelcome to the Yu-Gi-Oh Trading Card Gameoooooo------------\n");
	printf("Welcome to dueler's kindgom\n");
	printf("Are you ready to play?\n");
   pf = (Playing_Field_p)malloc(sizeof(Playing_Field));
   InitMagicTrap();
   SetUpPlayer();sleep(1);
   SetUpOpponent();sleep(1);
   Shuffle();sleep(1);
   CreateSideDeck();
   SetUpBoards();
   who_won = Duel();
   if(who_won == 1)
   	printf("Congratulations Player 1, you've won the duel!!!!!!!!!\n");
   else
   	printf("Aww the computer won.  You suck!!!\n");
   fflush(NULL);
   getchar();
   getchar();
	return 0;
	}



