/***************************************************
Copyright 2003 Darrell Johnson 

This file is part of Yu-gi-oh.

Yu-gi-oh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yu-gi-oh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Yu-gi-oh; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <dos.h>

#include "datatypes3.h"

extern Playing_Field_p pf;

extern int magic_trap_active[MAGICTRAP];
extern int magic_trap_active2[MAGICTRAP];

char magic_trap_registry[MAGICTRAP][40] = {"Armored Glass", "Castle Walls", "Dragon Capture Jar",
"Earthshaker", "Reinforcements", "Respect Play", "Trap Hole", "Two-pronged Attack",
"Ultimate Offering", "Waboku", "Book of Secret Arts", "Card Destruction", "Change of Heart", "Dark Hole",
"De-Spell", "Dian Keto the Cure Master", "Fissure", "Last Will", "Monster Reborn",
"Monster Recovery", "Remove Trap", "Soul Exchange", "Sword of Dark Destruction", "Yami", "Reverse Trap"};

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
///////////////////////////////Player 1 Functions///////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

void DrawPhase(Player_p p){
	p->in_hand[p->ohp] = p->entire_deck->deck[p->entire_deck->topcardpos];
   p->ohp++;
   p->entire_deck->topcardpos++;
   p->entire_deck->numcards--;
   printf("%s has drawn %s.\n",p->name, p->in_hand[p->ohp-1]->name);
   }
   
void StandbyPhase(void){
	sleep(1);
   }

int MainPhaseI(Player_p p, Board_p b){
	int i, in1, in2, choice, another_card, anq, battleready, sa, success;
	battleready = anq = 0;

   printf("You are currently holding: \n");
   do{
   	for(i=0; i< p->ohp;i++){
      printf("------------------------------------\n");
   	printf("%d. %s (atk %d / def %d) || level: %d || type: %s || attribute: %s\n", i, p->in_hand[i]->name, p->in_hand[i]->atk,
      	p->in_hand[i]->def, p->in_hand[i]->level, p->in_hand[i]->type, p->in_hand[i]->attribute);
      printf("%s\n", p->in_hand[i]->description);
      printf("------------------------------------\n");
      }
      
		printf("(a)ttack, (l)ook up card info, (s)witch cards from side deck: ");
   	fflush(stdin);
   	choice = getletter();
      fflush(stdin);

   	while(choice != 'a' && choice != 's' && choice != 'l'){
   		printf("(a)ttack, (l)ook up card info, (s)witch cards from side deck: ");
   		choice = getletter();
      	}

   	if(choice == 'l')
   		CardQuery();
   	if(choice == 's')
   		UseSideDeck();
  	}while(choice != 'a');

   do{
   	another_card = 0; success = 1; anq = 0;
   	for(i=0; i< p->ohp;i++)
   	printf("%d. %s (atk %d / def %d) level %d\n", i, p->in_hand[i]->name, p->in_hand[i]->atk,
      	p->in_hand[i]->def, p->in_hand[i]->level);
   	printf("\nWhich card would you like to play?(0-%d): ", p->ohp-1);
      fflush(stdin);
   	in1 = getnumber();
   	fflush(stdin);

   	while(in1 > p->ohp){
   		printf("\nWhich card would you like to play?(0-5): ");
   		in1 = getnumber();
      	}

      if(in1 == -1) break;

   	if(p->in_hand[in1]->atk == -1){
      	printf("Placing on magic/trap card space.\n");
         if(!strcmp(p->in_hand[in1]->attribute, "trap") ){
         	printf("Setting %s.\n", p->in_hand[in1]->name);
         	PlaceOnBoard(p->in_hand[in1], pf->b1, 0, 0, 1);
         	UpdateHand(p, in1);
            }
         else{
         	printf("Set or Activate card? \nTrap cards must be set, Magic cards can be set or activated (s or a): ");
         	sa = getletter();
         	while(sa != 's' && sa != 'a'){
         		printf("Set or Activate card? (s or a): ");
         		sa = getletter();
            	}
         	if(sa == 's'){
         		printf("Setting %s for later use.\n", p->in_hand[in1]->name);
         		PlaceOnBoard(p->in_hand[in1], pf->b1, 0, 0, 1);
         		UpdateHand(p, in1);
            	}
         	if(sa == 'a'){
         		printf("Activating %s...\n", p->in_hand[in1]->name);
            	MagicAndTrapCards(p->in_hand[in1]->name);
               if(strcmp(p->in_hand[in1]->icon, "continuous")){
               	printf("%s played and now going to Graveyard.\n", pf->b1->position[i]->card->name);
                  MoveToGraveyard(pf->b1->position[i]->card, pf->b1, 1, i);
                  }
         		else
               	PlaceOnBoard(p->in_hand[in1], pf->b1, 1, 0, 1);
         		UpdateHand(p, in1);
            	}
            }
         printf("Since you played a magic/trap card, you have the option to play another card.\n");
         another_card = 1;
         }
   	else{
         if(p->in_hand[in1]->level > 4)
         	success = SummonHighLevel(in1, p, b);
         if(!success)
               in1 = -1;
         else{
    		 printf("Place in (a)ttack or (d)efense mode: ");
    		 in2 = getletter();
    		 fflush(stdin);
    		 if(in2 == 'a'){
   			printf("%s placed in attack mode\n", p->in_hand[in1]->name);
      		PlaceOnBoard(p->in_hand[in1], b, 1, 1, 0);
      		UpdateHand(p, in1);
            }
    		 else{
   			printf("%s placed in defense mode\n", pf->p1->in_hand[in1]->name);
      		PlaceOnBoard(p->in_hand[in1], b, 0, 0, 0);
      		UpdateHand(p, in1);
      			}
   		 }//end 2nd else
         }
      while (another_card && anq != 'y' && anq != 'n' && in1 >= 0 ){
      	 printf("Would you like to play another card? (y/n): ");
          anq = getletter();
          fflush(stdin);
          if(anq == 'n')
         	another_card = 0;
        }//
   }while(another_card || (in1 < 0) );

   printf("Current state of your board: \n");
   for(i=0; i<10; i++){
   	if(b->position[i]->pos == -1 || (b->position[i]->card->name == NULL) )
      	continue;
      else if(b->position[i]->pos == 0)
      	printf("%d. %s atk %d/ def %d in defense mode\n", i, b->position[i]->card->name,
      	b->position[i]->card->atk, b->position[i]->card->def);
      else{ printf("%d. %s atk %d/ def %d in attack mode\n", i, b->position[i]->card->name,
      	b->position[i]->card->atk, b->position[i]->card->def);
         battleready = 1;  //indicates able to go into battle phase
         }
		}

   printf("Would you like to change any cards from attack mode to defense mode, or vice-versa? (y/n): ");
   fflush(stdin);
   in2 = getletter();
   fflush(stdin);
   while(in2 == 'y'){
   	printf("Which card do you want to change? ");
      fflush(stdin);
      in1 = getnumber();
   	fflush(stdin);
      if(b->position[in1]->pos == 0 && !b->position[in1]->set){
      	printf("Changing %s to attack mode.\n", b->position[in1]->card->name);
         b->position[in1]->pos = 1;
         b->position[in1]->set = 1;
         }
      else if(b->position[in1]->pos == 1 && !b->position[in1]->set){
      	printf("Changing %s to defense mode.\n", b->position[in1]->card->name);
         b->position[in1]->pos = 0;
         b->position[in1]->set = 1;
         }
      else printf("You may have already changed this card's position once.\n");
      printf("Anymore changes? (y/n): ");
      in2 = getletter();
   	fflush(stdin);
      }

   if(battleready){
   	printf("Go to Battle Phase? (y/n): ");
      in2 = getletter();
      if(in2 == 'n') battleready = 0;
      }
   return battleready;
}

int BattlePhase(Player_p p, Board_p b){
	int i, j, played, monster_there, atkr, trap_card_playable, counter_trap_playable, mtval;
   char playedalready[5][40];

   j = 0;
   trap_card_playable = CheckTrapPlayable(b);
	counter_trap_playable = CheckCounterPlayable(b);

   pf->step = 1;	//1 = start step
	mtval = CheckMagicTrapPlay(trap_card_playable, counter_trap_playable);

   if(mtval != 1){
//////////////Start Step
   printf("\n#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#\n");
   printf("Entering Battle Phase.\n");
   UpdateScreen();
   printf("\n#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#\n");
//////////////Battle Step
   atkr = Attacking_Monster(b);
   if(atkr == -1) return -1;
   do{ ///first open brace
   	pf->step = 2;	//2 = battle step
      played = 0;
      if( (b->position[atkr]->card->name == NULL) ){
      	printf("No monster is there.  End turn.\n");
         return 1;
         }
   	for(i=0;i<j;i++)
   		if(strcmp(playedalready[i], b->position[atkr]->card->name) == 0)
      		played = 1;
      strcpy(playedalready[j], b->position[atkr]->card->name);
      j++;
   	if(!played){
   	 monster_there = Check_Monster_To_Attack(pf->b2);
		 if(!monster_there){
   		pf->p2->lifepoints -= b->position[atkr]->card->atk;
      	printf("You attacked the opponent's lifepoints directly with %s!\n", b->position[atkr]->card->name);
      	printf("Comp-U-Dueler has %d lifepoints remaining.\n", pf->p2->lifepoints);
      	}
       else{
      	Monster_To_Attack(pf->b2);
   		mtval = CheckMagicTrapPlay(trap_card_playable, counter_trap_playable);
         pf->step = 3;	//3 = battle step
   		if(mtval != 1 && mtval != 2) DamageStep(p, b);
         pf->step = 4;	//4 = end step
         }
       CheckForMagicTrapEffects();
       UpdateScreen();
       }
       printf("Remember you may use each monster on the field once per round.\n");
       printf("Select another card (0 - 5) to attack with, or -1 to end battle phase. ");
       atkr = Attacking_Monster(b);
  }while(atkr != -1 || mtval == 1);
  printf("Battle Phase ended.\n");
  } //end if mtval == 2
  return 1;
}
