/***************************************************
Copyright 2003 Darrell Johnson 

This file is part of Yu-gi-oh.

Yu-gi-oh is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yu-gi-oh is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Yu-gi-oh; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <dos.h>

#include "datatypes3.h"

extern Playing_Field_p pf;

extern int magic_trap_active[MAGICTRAP];
extern int magic_trap_active2[MAGICTRAP];

char magic_trap_registry[MAGICTRAP][40] = {"Armored Glass", "Castle Walls", "Dragon Capture Jar",
"Earthshaker", "Reinforcements", "Respect Play", "Trap Hole", "Two-pronged Attack",
"Ultimate Offering", "Waboku", "Book of Secret Arts", "Card Destruction", "Change of Heart", "Dark Hole",
"De-Spell", "Dian Keto the Cure Master", "Fissure", "Last Will", "Monster Reborn",
"Monster Recovery", "Remove Trap", "Soul Exchange", "Sword of Dark Destruction", "Yami", "Reverse Trap"};

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
/////////////////////////Computer Opponent Functions////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

void CompDrawPhase(Player_p p){
	p->in_hand[p->ohp] = p->entire_deck->deck[p->entire_deck->topcardpos];
   p->ohp++;
   p->entire_deck->topcardpos++;
   printf("%s has drawn %s.\n",p->name, p->in_hand[p->ohp-1]->name);
   }

int CompMainPhaseI(Player_p p, Board_p b){
	int success, i, card;
   card = i = success = 1;
   while(i < p->ohp && p->in_hand[card]->atk == -1 ){
   	card++;
      i++;
      }
   if(i == p->ohp){
   	card = 0;
      for(i=0;i<15;i++){
      	if(p->side_deck->deck[i]->atk != -1 && p->side_deck->deck[i]->level < 5 && p->sdc_used[i] != 1){
         	p->in_hand[p->ohp] = p->side_deck->deck[i];
            p->ohp++;
            p->sdc_used[i] = 1;
            card = i;
            break;
            }
         }
      }
   if(card > p->ohp-1) card = p->ohp-1;
   if(p->in_hand[card]->atk == -1 && p->in_hand[card]->def == -1){
   	PlaceOnBoard(p->in_hand[card], b, 0, 0, 1);
      UpdateHand(p, card);
      printf("Comp-U-Dueler played a card faced down on board position %d in attack mode\n", b->nomtp-1);
      }
   else{
     // if(1){	//for now the computer will always try to attack
     // if(p->in_hand[card]->level > 4)
     // 	success = CompSummonHighLevel(card, p, b);
     // if(success){
   	 printf("%s placed in attack mode\n", p->in_hand[card]->name);
       PlaceOnBoard(p->in_hand[card], b, 1, 1, 0);
       UpdateHand(p, card);
       return 1;
     //  }
      //}
    /*else{
   	printf("%s placed in defense mode\n", p->in_hand[card]->name);
      PlaceOnBoard(p->in_hand[card], b, 0, 0, 0);
      UpdateHand(p, card);
      }*/
    }
  return 0;
  }

void CompBattlePhase(Player_p p, Board_p b){
	int input1, input2, c, battle_atk1, battle_atk2, battle_def2,
   	trap_card_playable, counter_trap_playable, replay;
   replay = 1;
   pf->step = 1;	//1 = start step
 do{
    replay = 1;
    pf->step = 2;	//2 = battle step
   //main phase
   trap_card_playable = CheckTrapPlayable(pf->b1);
   counter_trap_playable = CheckCounterPlayable(pf->b1);

   input1 = rand() % 5;
   c=0;
   while(b->position[input1]->card->atk == -1 && (c < 10)){
   	input1 = rand() % 5;
      c++;
      }
   c = 0;
   while(b->position[input1]->pos == 0 && (c < 10)){
   	input1 = rand() % 5;
      c++;
      }
   c = 0;
   while(b->position[input1]->card->name == NULL && (c < 10)){
   	input1 = rand() % 5;
      c++;
      }

   if(c == 5){
   	printf("Comp-U-Dueler can't attack with anything this turn.\n");
      return;
      }

   printf("Comp-U-Dueler enters Battle Phase.\n");
   pf->step = 1;
   CheckMagicTrapPlay(trap_card_playable, counter_trap_playable);

   //new battle atk and def points for player 1, reflecting change by a magic/trap card.
   //if no changes are made to the atk and def points, nothing is affected.
   battle_atk1 = b->position[input1]->card->atk + b->position[input1]->magic_atk;

   printf("Comp-U-Dueler selected to attack with %s ", b->position[input1]->card->name);
   printf("%d / %d\n", b->position[input1]->card->atk,  b->position[input1]->card->def);
   pf->attacking_monster = input1;

   input2 = rand() % 5;
   c = 0;
   while(pf->b1->position[input2]->card->name == NULL && c < 10){
   	input2 = rand() % 5;
      c++;
      }

	if(c == 10){
   	printf("Comp-U-Dueler is attacking your life points directly.\n");
      pf->p1->lifepoints -= b->position[input1]->card->atk;
      printf("%d life points lost.\n", b->position[input1]->card->atk);
      return;
      }

   //new battle atk and def points for player 2, reflecting change by a magic/trap card.
   //if no changes are made to the atk and def points, nothing is affected.
   battle_atk2 = pf->b1->position[input2]->card->atk + pf->b1->position[input2]->magic_atk;
   battle_def2 = pf->b1->position[input2]->card->def + pf->b1->position[input2]->magic_def;

   printf("%s attacks %s ", b->position[input1]->card->name, pf->b1->position[input2]->card->name);
   printf("atk %d /def %d ", pf->b1->position[input2]->card->atk,  pf->b1->position[input2]->card->def);
   if(pf->b1->position[input2]->pos == 0)
   	printf("which is in defense mode.\n");
   else printf("which is in attack mode.\n");
   pf->being_attacked = input2;
   pf->step = 2;
   replay = CheckMagicTrapPlay(trap_card_playable, counter_trap_playable);
 }while(replay == 1);
   pf->step = 3;	//3 = damage phase
   if(replay != 3)CompDamageStep(battle_atk1, battle_atk2, battle_def2, b, p, input1, input2);
   pf->step = 4;	//4 = battle step
}

void CompDamageStep(int battle_atk1, int battle_atk2, int battle_def2, Board_p b,
	Player_p p, int input1, int input2){
   int result;
   if(pf->b1->position[input2]->pos == 0){  //if you're attacking a monster that is in defense mode
   	if(battle_atk1 > battle_def2){
      	printf("%s destroyed and sent to opponent's graveyard.\n", pf->b1->position[input2]->card->name);
         printf("Card was in defense mode so opponent loses no life points.\n");
         MoveToGraveyard(pf->b1->position[input2]->card, pf->b1, 0, input2);
         }
      else if(battle_atk1 == battle_def2){
      	printf("Comp-U-Dueler's attack was nullified by your card's defense.  Both cards remain.\n");
         printf("Neither player loses life points.\n");
         }
      else {
      	printf("Your defense was greater than Comp-U-Dueler's offense.  %s destroyed %s.\n",
         	pf->b1->position[input2]->card->name, b->position[input1]->card->name);
         printf("Comp-U-Dueler's monster is sent to the graveyard.\n");
         result = (battle_def2 - battle_atk1);
         printf("%d points deducted from its life points.\n", result);
         result = (p->lifepoints - result);
         p->lifepoints = result;
         printf("%d life points remain.\n", result);
         MoveToGraveyard(b->position[input1]->card, b, 0, input1);
         }
      } //end if
      //if you're attacking a monster that is in attack mode
   else{
   	if(battle_atk1 > battle_atk2){
      	printf("%s destroyed and sent to opponent's graveyard.\n", pf->b1->position[input2]->card->name);
         result = (battle_atk1 - battle_atk2);
         printf("%d points deducted from opponent's life points.\n", result);
         result = pf->p1->lifepoints - result;
         pf->p1->lifepoints = result;
         printf("%d life points remain.\n", result);
         MoveToGraveyard(pf->b1->position[input2]->card, pf->b1, 0, input2);
         }
      else if(battle_atk1 == battle_atk2){
      	printf("Comp-U-Dueler's attack was nullified by your card's attack.  Both cards destroyed and sent to graveyard.\n");
         printf("Neither player loses life points.\n");
         MoveToGraveyard(pf->b1->position[input2]->card, pf->b1, 0, input2);
         MoveToGraveyard(b->position[input1]->card, b, 0, input1);
         }
   	else {
      	printf("Your attack points were greater than Comp-U-Dueler's attack points.  %s destroyed %s.\n",
         	pf->b1->position[input2]->card->name, b->position[input1]->card->name);
         printf("Comp-U-Dueler's monster is sent to the graveyard.\n");
         result = (battle_atk2 - battle_atk1);
         printf("%d points deducted from its life points.\n", result);
         result = (p->lifepoints - result);
         p->lifepoints = result;
         printf("%d life points remain.\n", result);
         MoveToGraveyard(b->position[input1]->card, b, 0, input1);
         }
      }

}

int CompSummonHighLevel(int input1, Player_p p, Board_p b){
	int in2, in3, success;
   success = 0;
   if( (p->in_hand[input1]->level > 6) && (b->position[1]->card->name == NULL) ||
   	 (p->in_hand[input1]->level > 4) && (b->position[0]->card->name == NULL) ){
      	printf("It appears that you don't have enough monsters to offer as a tribute now.\n");
         }
   else{
   	in2 = 0;
      if(p->in_hand[input1]->level > 6){
      	in3 = 1;
         printf("Comp-U-Dueler offering %s and %s as a tribute to summon %s.\n",
         	b->position[in2]->card->name, b->position[in3]->card->name,
            p->in_hand[input1]->name);
         MoveToGraveyard(b->position[in2]->card, b, 0, in2);
         MoveToGraveyard(b->position[in3]->card, b, 0, in3);
         success = 1;
         }
      else{
      	printf("Comp-U-Dueler offering %s as a tribute to summon %s.\n",
         	b->position[in2]->card->name, p->in_hand[input1]->name);
         MoveToGraveyard(b->position[in2]->card, b, 0, in2);
         success = 1;
         }
      }
   return success;
}
